function [N, binEdges] = histcounts_custom(data, binEdges)
% This function was written as a Octave compatibility replacement for the
% Matlab's "histcounts" function. It is not a full-fledged replacement, but
% only for the special use cases of IFM Analyzer application.

try
    % use the Matab's built-in "histogram" function
    [N, binEdges] = histcounts(data, binEdges);
    %error('Some strign.'); % only for testing purposes
catch
    % use the Octave compatible "bar" function in a similar manner to the
    % "histcounts" function
    [N_temp, ~] = histc(data, binEdges);
    N=zeros(1, numel(N_temp)-1);     % always return in a row vector format
    N(:)=N_temp(1:end-1);
    N(end)=N(end)+N_temp(end);
end

end