# IFM Analyser

IFM Analyser is written in Mathworks MATLAB for dealing with the quantification of sarcomeric structures using pre defined templates (single line, double line, gap) in _drosophila_ flight muscles. For creating the graphical user interface, the MATLAB App Designer was used.

## Requirements

Any PC (with Linux or Windows) that can run Mathworks Matlab R2018b can run IFM Analyser. The software depends on rainSTORM v3.1.7+ to provide the exported localization data. See requirements for rainSTORM on [our software page](http://titan.physx.u-szeged.hu/~adoptim/?page_id=582).

### Tested on

The application has been tested on a Windows PC (Intel Core i7-6700K, 32GB DDR4, Intel HD Graphics 530, Windows 10 Pro 64-bit version 1809) running Mathworks MATLAB R2018b Update 4 (Image Processing Toolbox, Optimizations Toolbox, Parallel Computing Toolbox, Statistics and Machine Learning Toolbox).

## Installation

There are two ways to install IFM Analyser:

1. Install the MATLAB App package from the following [link]().
1. Clone the git repository:

```bash
git clone git@gitlab.com:adoptim/ifm-analyser.git
```

## Usage

**MATLAB app**: Open MATLAB click on the Apps tab, and run the IFM Analyser.

**Source code**: Open MATLAB, change the current directory to the repository folder.

```matlab
startup; IFMAnalyser
```

Please consult the wiki page (user guide) for additional information.

## Contributing

Pull requests are welcome. For major changes, please open an issue first to discuss what you would like to change. Please make sure to provide a demo dataset.

## License

[GPLv3](https://choosealicense.com/licenses/gpl-3.0/)