function modelFunc_Y_convolved = convolveModelFunction(modelFunc_Y, convFunc, modelFunc_dX)
% This function performs numerical convoluion on the model function with a
% convolution function.

% for testing, covlolution with a top-hat function:
%convRad_N=(numel(convFunc)-1)/2
%convFuncSize=2*convRad_N+1;
%convFunc=ones(convFuncSize,1);

% radius of the convolution function:
convRad_N=uint16((numel(convFunc)-1)/2);

% initialization of the convolved model function:
% it should be smaller than the original with the size of the convolution
% function
modelFunc_Y_convolved=zeros(size(modelFunc_Y(convRad_N+1:end-convRad_N)));

% numerical calculation of the convolution:
for idxSamp=(convRad_N+1):(size(modelFunc_Y_convolved,1)+convRad_N)
    modelFunc_Y_convolved(idxSamp-convRad_N)=sum(modelFunc_Y(idxSamp-convRad_N:idxSamp+convRad_N).*convFunc)*modelFunc_dX;
end

% for testing, comparison of the model function prior and after the
% convolution:
%figure()
%plot(modelFunc_sampling_X, modelFunc_Y)


end

