function [histCounts, histEdges] = lineDiameter_fit_getHistogram(histEdges_cell, histCounts_cell, locLineDist, ThompsonPrec, precBounds)
% TODO: ezt még át kéne gondolni, mindig készítsem új hisztogramot a
% "locLineDist" adatokból, vagy maradjon az "if"-es szerkezet?

% number of the different lines
histEdges_cellN=numel(histEdges_cell);

if precBounds(1)==-Inf && precBounds(2)==Inf
   
    locLineDist_filtered=locLineDist(~isnan(locLineDist));
    
    % determining whether the histogram edges matches for all the different lines
    matchingHist_bool=true;
    if histEdges_cellN>1
        for idxLine=2:histEdges_cellN
            if numel(histEdges_cell{1,1})==numel(histEdges_cell{idxLine,1})
                matchingHist_boolVect=histEdges_cell{1,1}==histEdges_cell{idxLine,1};
                matchingHist_bool=prod(matchingHist_boolVect);
            else
                matchingHist_bool=false;
            end
        end
        
        % if they do not match
        if ~matchingHist_bool
            error('There is a problem with the histogram data, histogram edges does not match for the different lines.')
        end
        
    end
    
    % if the histogram edges matches for all the different lines
    if matchingHist_bool
        histEdges=histEdges_cell{1};
        
        % calculate the mean values of the histogram counts for all the
        % different lines
        histCounts_mat=cell2mat(histCounts_cell);
        histCounts=mean(histCounts_mat, 1);
    else
        histEdges=histEdges_cell{1};
        histCounts=histcounts_custom(locLineDist_filtered, histEdges);
    end
    
else
    locFilterBool=true(size(locLineDist));
    locFilterBool(isnan(locLineDist))=false;
    locFilterBool(ThompsonPrec<precBounds(1) | ThompsonPrec>precBounds(2))=false;
    
    locLineDist_filtered=locLineDist(locFilterBool);
    
    histEdges=histEdges_cell{1};
    histCounts=histcounts_custom(locLineDist_filtered, histEdges);
    
end

% the edges of the histogram bins of the data:
histCounts=histCounts';
% the edges of the histogram bins of the data:
histEdges=histEdges';
% the histogram bins should be equally sized!!!!!

end

