function [locPrecision] = lineDiameter_fit_getPrecision(locPrecision_manuallySet, ThompsonPrec, precBounds, multiPrecBool)
% This function calculates the localizaation precision usef for the model
% function smearing. It can be an average of the standard deviations or the
% Gaussian functions (calculated later, in this case the precision is a 
% multi element vector) or the manually set value.


if precBounds(1)==-Inf && precBounds(2)==Inf
   
    ThompsonPrec_filtered=ThompsonPrec(~isnan(ThompsonPrec));
    
else
    locFilterBool=true(size(locLineDist));
    locFilterBool(isnan(locLineDist))=false;
    locFilterBool(ThompsonPrec<precBounds(1) | ThompsonPrec>precBounds(2))=false;
    
    ThompsonPrec_filtered=ThompsonPrec(locFilterBool);
    
end


if multiPrecBool==false
    if isempty(locPrecision_manuallySet)
        locPrecision=mean(ThompsonPrec_filtered);
    else
        locPrecision=locPrecision_manuallySet;
    end
else
    locPrecision=ThompsonPrec_filtered;
end

end

