function [m, h] = drawStraightLine(figureHandle)
% This function lets the user to draw segmented line of the given figure.
% The line is only accepted is straight, i.e. has only two defined points.
% Returns the slope and the incision height of the line.
% 
% [m, h] = drawStraightLine(figureHandle)
% 
% Inputs:
% 
% - figureHandle: handle of the figure on which the straight line shall be drawn
% 
% Outputs:
% 
% - m: slope of the drawn line
% - h: intercept of the drawn line


% accept only straight line (when exactly two points were clicked on):
points=[];
while size(points, 1)~=2
    % the points selected by the user:
    points=getline(figureHandle);
    
end

% the slope of the line:
m=(points(1,2)-points(2,2))/(points(1,1)-points(2,1));

%  the incision height of the line:
h=points(1,2)-m*points(1,1);

end

