% Launch script for aligning the individual single band (single line),
% double band (double line) or gap structures and merging them into a single
% image.

%% input parameters to set:
mergeParams.sizeX=4000;         % "x" size of  the "meged" super-resolved image in nm
mergeParams.sizeY=4000;         % "y" size of  the "meged" super-resolved image in nm
mergeParams.pixelSize=10;       % size of the pixels in the "meged" super-resolved image
% interpolation methods for the straightening:
mergeParams.interp='linear';
%mergeParams.interp='pchip';
%mergeParams.interp='spline';
mergeParams.bound=100;          % boundary region size for the curve for the straightening
mergeParams.stepsize=0.5;       % sampling step for the curve for the straightening
mergeParams.onlyfinal=true;     % Output only the final merged image.
mergeParams.outputInFigure=true;% Output in figure format.

mergeParams.crop = false;
mergeParams.CropX = 1000;
mergeParams.CropY = 100;

%% reading the histogram data files containing the structures to be aligned
mergeLineDiamHistData=[];
% pop-up window for opening one or several files
[histDataFileNames, histDataFilePath]= uigetfile({'*.mat'}, 'Open the histogram data files.','MultiSelect','on');
% creating a cell list from the selected files
if histDataFilePath==0
    disp('User cancelled selection');
else
    % number of the chosen histogram data files
    if iscell(histDataFileNames)
        N_histDataFiles=numel(histDataFileNames);   % if multiple files were chosen, the names are stored in a cell array
    else
        N_histDataFiles=1;      % if a single file was chosen, the name is stored in a string
    end
    mergeLineDiamHistData=cell(1,N_histDataFiles);
    if N_histDataFiles==1
        %disp(['Regex selected ', fullfile(sectionsPath,sectionDataFiles(idxSection).name)]);
        [~,sectionName,~]=fileparts(histDataFileNames);
        mergeLineDiamHistData{1}=fullfile(histDataFilePath, histDataFileNames);
    elseif N_histDataFiles>1
        for idxSection = 1:N_histDataFiles
            %disp(['Regex selected ', fullfile(sectionsPath,sectionDataFiles(idxSection).name)]);
            [~,sectionName,~]=fileparts(histDataFileNames{idxSection});
            mergeLineDiamHistData{idxSection}=fullfile(histDataFilePath, histDataFileNames{idxSection});
        end
    end
end

%% aligning and merging the structures
[~] = rainSTORM_extras_lineDiameter_merge(mergeLineDiamHistData,mergeParams);