function [lineLength, fig] = external_fit_tool(a, filename, mode)

array = a*1000; % um->nm conversion
%array = a;
switch mode
    case 1
        lev50 = 0.29;
        Histogram.BinWidth = (array(2,1) - array(1,1));
        Histogram.NumBins = length(array);
        Histogram.BinEdges = array(:,1);
        Histogram.BinCounts = array(:,2);
        
        fig = figure('Name',filename);
        plot(array(:,1),array(:,2));
        % The distribution curve is displayed, but not used.
        hold on
        title([num2str(Histogram.NumBins), ' bins & fwhm ', num2str(lev50)]);
        ylabel('Intensity in bins');
        [lineLength, tt, tl] = fwhm(Histogram.BinEdges', Histogram.BinCounts', lev50);
        xline(tl);
        xline(tt);
        yline(max(Histogram.BinCounts)*lev50);
        xlabel(['Diameter: ', num2str(lineLength), ' nm']);
        hold off
    case 2
        modeltype = 'Rectangular';
        Histogram.BinWidth = (array(2,1) - array(1,1));
        Histogram.NumBins = length(array);
        Histogram.BinEdges = (array(1,1)-Histogram.BinWidth/2:Histogram.BinWidth:array(end,1)+Histogram.BinWidth/2);
        Histogram.BinCounts = array(:,2)';
        
        [densFuncWidth_fitted, fig]=lineDiameter_singlerectfit(...
            0, Histogram, 'Gaussian', modeltype, 160 );
        lineLength = densFuncWidth_fitted; % densFuncSize_fitted;
        figure(fig);
    case 3
        modeltype = 'Disk';
        Histogram.BinWidth = (array(2,1) - array(1,1));
        Histogram.NumBins = length(array);
        Histogram.BinEdges = (array(1,1)-Histogram.BinWidth/2:Histogram.BinWidth:array(end,1)+Histogram.BinWidth/2);
        Histogram.BinCounts = array(:,2)';
        
        [densFuncWidth_fitted, fig]=lineDiameter_singlerectfit(...
            0, Histogram, 'Gaussian', modeltype, 160 );
        lineLength = densFuncWidth_fitted; % densFuncSize_fitted;
        figure(fig);
    case 4
        modeltype = 'Circle';
        Histogram.BinWidth = (array(2,1) - array(1,1));
        Histogram.NumBins = length(array);
        Histogram.BinEdges = (array(1,1)-Histogram.BinWidth/2:Histogram.BinWidth:array(end,1)+Histogram.BinWidth/2);
        Histogram.BinCounts = array(:,2)';
        
        [densFuncWidth_fitted, fig]=lineDiameter_singlerectfit(...
            0, Histogram, 'Gaussian', modeltype, 160);
        lineLength = densFuncWidth_fitted; % densFuncSize_fitted;
        figure(fig);
        
    case 5
        modeltype = 'Ring';
        Histogram.BinWidth = (array(2,1) - array(1,1));
        Histogram.NumBins = length(array);
        Histogram.BinEdges = (array(1,1)-Histogram.BinWidth/2:Histogram.BinWidth:array(end,1)+Histogram.BinWidth/2);
        Histogram.BinCounts = array(:,2)';
        
        [densFuncWidth_fitted, fig]=lineDiameter_singlerectfit(...
            0, Histogram, 'Gaussian', modeltype, 160);
        lineLength = densFuncWidth_fitted; % densFuncSize_fitted;
        figure(fig);
        
        %Megjegyzs a gyr vastagsgt a "lineDiameter_fit" en vagy a"lineDiameter_singlerectfit"-en
        %bell lehet lltani, ezen mg lehet, hogy vltoztatni kne.
        % Olyan ~300nm-es Gauss elmosssal jobban illeszt, mint a 160nm-sel
        
end

end

